Index: branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/RK3_SRC/TRA/traadv.F90
===================================================================
--- branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/RK3_SRC/TRA/traadv.F90	(revision 8367)
+++ branches/2017/dev_r7881_ENHANCE09_RK3/NEMOGCM/NEMO/RK3_SRC/TRA/traadv.F90	(revision 8568)
@@ -14,9 +14,11 @@
    !!----------------------------------------------------------------------
    !!   tra_adv       : compute ocean tracer advection trend
-   !!   tra_adv_ctl   : control the different options of advection scheme
+   !!   tra_adv_init  : control the different options of advection scheme
    !!----------------------------------------------------------------------
    USE oce            ! ocean dynamics and active tracers
    USE dom_oce        ! ocean space and time domain
    USE domvvl         ! variable vertical scale factors
+   USE sbcwave        ! wave module
+   USE sbc_oce        ! surface boundary condition: ocean
    USE traadv_cen     ! centered scheme           (tra_adv_cen  routine)
    USE traadv_fct     ! FCT      scheme           (tra_adv_fct  routine)
@@ -27,6 +29,7 @@
    USE ldftra         ! lateral diffusion: eddy diffusivity & EIV coeff.
    USE ldfslp         ! Lateral diffusion: slopes of neutral surfaces
-   USE trd_oce         ! trends: ocean variables
-   USE trdtra          ! trends manager: tracers 
+   USE trd_oce        ! trends: ocean variables
+   USE trdtra         ! trends manager: tracers 
+   USE diaptr         ! Poleward heat transport 
    !
    USE in_out_manager ! I/O manager
@@ -34,22 +37,18 @@
    USE prtctl         ! Print control
    USE lib_mpp        ! MPP library
-   USE wrk_nemo       ! Memory Allocation
    USE timing         ! Timing
-   USE sbcwave        ! wave module
-   USE sbc_oce        ! surface boundary condition: ocean
-   USE diaptr         ! Poleward heat transport 
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   tra_adv        ! routine called by step module
-   PUBLIC   tra_adv_init   ! routine called by opa module
+   PUBLIC   tra_adv        ! called by step.F90
+   PUBLIC   tra_adv_init   ! called by nemogcm.F90
 
    !                            !!* Namelist namtra_adv *
+   LOGICAL ::   ln_traadv_NONE   ! no advection on T and S
    LOGICAL ::   ln_traadv_cen    ! centered scheme flag
    INTEGER ::      nn_cen_h, nn_cen_v   ! =2/4 : horizontal and vertical choices of the order of CEN scheme
    LOGICAL ::   ln_traadv_fct    ! FCT scheme flag
    INTEGER ::      nn_fct_h, nn_fct_v   ! =2/4 : horizontal and vertical choices of the order of FCT scheme
-   INTEGER ::      nn_fct_zts           ! >=1 : 2nd order FCT with vertical sub-timestepping
    LOGICAL ::   ln_traadv_mus    ! MUSCL scheme flag
    LOGICAL ::      ln_mus_ups           ! use upstream scheme in vivcinity of river mouths
@@ -58,19 +57,17 @@
    LOGICAL ::   ln_traadv_qck    ! QUICKEST scheme flag
 
-   INTEGER ::              nadv             ! choice of the type of advection scheme
-   !
-   !                                        ! associated indices:
+   INTEGER ::   nadv             ! choice of the type of advection scheme
+   !                             ! associated indices:
    INTEGER, PARAMETER ::   np_NO_adv  = 0   ! no T-S advection
    INTEGER, PARAMETER ::   np_CEN     = 1   ! 2nd/4th order centered scheme
    INTEGER, PARAMETER ::   np_FCT     = 2   ! 2nd/4th order Flux Corrected Transport scheme
-   INTEGER, PARAMETER ::   np_FCT_zts = 3   ! 2nd order FCT scheme with vertical sub-timestepping
-   INTEGER, PARAMETER ::   np_MUS     = 4   ! MUSCL scheme
-   INTEGER, PARAMETER ::   np_UBS     = 5   ! 3rd order Upstream Biased Scheme
-   INTEGER, PARAMETER ::   np_QCK     = 6   ! QUICK scheme
+   INTEGER, PARAMETER ::   np_MUS     = 3   ! MUSCL scheme
+   INTEGER, PARAMETER ::   np_UBS     = 4   ! 3rd order Upstream Biased Scheme
+   INTEGER, PARAMETER ::   np_QCK     = 5   ! QUICK scheme
    
    !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.7 , NEMO Consortium (2014)
+   !! NEMO/OPA 4.0 , NEMO Consortium (2017)
    !! $Id$
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
@@ -86,27 +83,22 @@
       !! ** Method  : - Update (ua,va) with the advection term following nadv
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !
       INTEGER ::   jk   ! dummy loop index
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: zun, zvn, zwn
-      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrdt, ztrds   ! 3D workspace
-      !!----------------------------------------------------------------------
-      !
-      IF( nn_timing == 1 )  CALL timing_start('tra_adv')
-      !
-      CALL wrk_alloc( jpi,jpj,jpk,   zun, zvn, zwn )
+      REAL(wp), DIMENSION(jpi,jpj,jpk)        :: zun, zvn, zwn   ! 3D workspace
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrdt, ztrds
+      !!----------------------------------------------------------------------
+      !
+      IF( ln_timing )   CALL timing_start('tra_adv')
       !
       !                                          ! set time step
-      zun(:,:,:) = 0.0
-      zvn(:,:,:) = 0.0
-      zwn(:,:,:) = 0.0
-      !    
-      IF( neuler == 0 .AND. kt == nit000 ) THEN     ! at nit000
-         r2dt = rdt                                 ! = rdt (restarting with Euler time stepping)
-      ELSEIF( kt <= nit000 + 1) THEN                ! at nit000 or nit000+1
-         r2dt = 2._wp * rdt                         ! = 2 rdt (leapfrog)
+      IF( neuler == 0 .AND. kt == nit000 ) THEN   ;   r2dt =        rdt   ! at nit000             (Euler)
+      ELSEIF( kt <= nit000 + 1 )           THEN   ;   r2dt = 2._wp* rdt   ! at nit000 or nit000+1 (Leapfrog)
       ENDIF
       !
       !                                         !==  effective transport  ==!
+      zun(:,:,jpk) = 0._wp
+      zvn(:,:,jpk) = 0._wp
+      zwn(:,:,jpk) = 0._wp
       IF( ln_wave .AND. ln_sdw )  THEN
          DO jk = 1, jpkm1                                                       ! eulerian transport + Stokes Drift
@@ -146,5 +138,5 @@
       !
       IF( l_trdtra )   THEN                    !* Save ta and sa trends
-         CALL wrk_alloc( jpi, jpj, jpk, ztrdt, ztrds )
+         ALLOCATE( ztrdt(jpi,jpj,jpk), ztrds(jpi,jpj,jpk) )
          ztrdt(:,:,:) = tsa(:,:,:,jp_tem)
          ztrds(:,:,:) = tsa(:,:,:,jp_sal)
@@ -153,15 +145,13 @@
       SELECT CASE ( nadv )                      !==  compute advection trend and add it to general trend  ==!
       !
-      CASE ( np_CEN )                                    ! Centered scheme : 2nd / 4th order
+      CASE ( np_CEN )                                 ! Centered scheme : 2nd / 4th order
          CALL tra_adv_cen    ( kt, nit000, 'TRA',         zun, zvn, zwn     , tsn, tsa, jpts, nn_cen_h, nn_cen_v )
-      CASE ( np_FCT )                                    ! FCT scheme      : 2nd / 4th order
+      CASE ( np_FCT )                                 ! FCT scheme      : 2nd / 4th order
          CALL tra_adv_fct    ( kt, nit000, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts, nn_fct_h, nn_fct_v )
-      CASE ( np_FCT_zts )                                ! 2nd order FCT with vertical time-splitting
-         CALL tra_adv_fct_zts( kt, nit000, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts        , nn_fct_zts )
-      CASE ( np_MUS )                                    ! MUSCL
+      CASE ( np_MUS )                                 ! MUSCL
          CALL tra_adv_mus    ( kt, nit000, 'TRA', r2dt, zun, zvn, zwn, tsb,      tsa, jpts        , ln_mus_ups ) 
-      CASE ( np_UBS )                                    ! UBS
+      CASE ( np_UBS )                                 ! UBS
          CALL tra_adv_ubs    ( kt, nit000, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts        , nn_ubs_v   )
-      CASE ( np_QCK )                                    ! QUICKEST
+      CASE ( np_QCK )                                 ! QUICKEST
          CALL tra_adv_qck    ( kt, nit000, 'TRA', r2dt, zun, zvn, zwn, tsb, tsn, tsa, jpts                     )
       !
@@ -175,5 +165,5 @@
          CALL trd_tra( kt, 'TRA', jp_tem, jptra_totad, ztrdt )
          CALL trd_tra( kt, 'TRA', jp_sal, jptra_totad, ztrds )
-         CALL wrk_dealloc( jpi, jpj, jpk, ztrdt, ztrds )
+         DEALLOCATE( ztrdt, ztrds )
       ENDIF
       !                                              ! print mean trends (used for debugging)
@@ -181,8 +171,6 @@
          &                       tab3d_2=tsa(:,:,:,jp_sal), clinfo2=       ' Sa: ', mask2=tmask, clinfo3='tra' )
       !
-      IF( nn_timing == 1 )  CALL timing_stop( 'tra_adv' )
-      !
-      CALL wrk_dealloc( jpi,jpj,jpk,   zun, zvn, zwn )
-      !                                          
+      IF( ln_timing )   CALL timing_stop( 'tra_adv' )
+      !
    END SUBROUTINE tra_adv
 
@@ -197,9 +185,10 @@
       INTEGER ::   ioptio, ios   ! Local integers
       !
-      NAMELIST/namtra_adv/ ln_traadv_cen, nn_cen_h, nn_cen_v,               &   ! CEN
-         &                 ln_traadv_fct, nn_fct_h, nn_fct_v, nn_fct_zts,   &   ! FCT
-         &                 ln_traadv_mus,                     ln_mus_ups,   &   ! MUSCL
-         &                 ln_traadv_ubs,           nn_ubs_v,               &   ! UBS
-         &                 ln_traadv_qck                                        ! QCK
+      NAMELIST/namtra_adv/ ln_traadv_NONE,                       &   ! No advection
+         &                 ln_traadv_cen , nn_cen_h, nn_cen_v,   &   ! CEN
+         &                 ln_traadv_fct , nn_fct_h, nn_fct_v,   &   ! FCT
+         &                 ln_traadv_mus , ln_mus_ups,           &   ! MUSCL
+         &                 ln_traadv_ubs ,           nn_ubs_v,   &   ! UBS
+         &                 ln_traadv_qck                             ! QCK
       !!----------------------------------------------------------------------
       !
@@ -217,6 +206,7 @@
          WRITE(numout,*)
          WRITE(numout,*) 'tra_adv_init : choice/control of the tracer advection scheme'
-         WRITE(numout,*) '~~~~~~~~~~~'
+         WRITE(numout,*) '~~~~~~~~~~~~'
          WRITE(numout,*) '   Namelist namtra_adv : chose a advection scheme for tracers'
+         WRITE(numout,*) '      No advection on T & S                     ln_traadv_NONE= ', ln_traadv_NONE
          WRITE(numout,*) '      centered scheme                           ln_traadv_cen = ', ln_traadv_cen
          WRITE(numout,*) '            horizontal 2nd/4th order               nn_cen_h   = ', nn_fct_h
@@ -225,5 +215,4 @@
          WRITE(numout,*) '            horizontal 2nd/4th order               nn_fct_h   = ', nn_fct_h
          WRITE(numout,*) '            vertical   2nd/4th order               nn_fct_v   = ', nn_fct_v
-         WRITE(numout,*) '            2nd order + vertical sub-timestepping  nn_fct_zts = ', nn_fct_zts
          WRITE(numout,*) '      MUSCL scheme                              ln_traadv_mus = ', ln_traadv_mus
          WRITE(numout,*) '            + upstream scheme near river mouths    ln_mus_ups = ', ln_mus_ups
@@ -233,16 +222,14 @@
       ENDIF
       !
-      ioptio = 0                       !==  Parameter control  ==!
-      IF( ln_traadv_cen )   ioptio = ioptio + 1
-      IF( ln_traadv_fct )   ioptio = ioptio + 1
-      IF( ln_traadv_mus )   ioptio = ioptio + 1
-      IF( ln_traadv_ubs )   ioptio = ioptio + 1
-      IF( ln_traadv_qck )   ioptio = ioptio + 1
-      !
-      IF( ioptio == 0 ) THEN
-         nadv = np_NO_adv
-         CALL ctl_warn( 'tra_adv_init: You are running without tracer advection.' )
-      ENDIF
-      IF( ioptio /= 1 )   CALL ctl_stop( 'tra_adv_init: Choose ONE advection scheme in namelist namtra_adv' )
+      !                                !==  Parameter control & set nadv ==!
+      ioptio = 0                       
+      IF( ln_traadv_NONE ) THEN   ;   ioptio = ioptio + 1   ;   nadv = np_NO_adv   ;   ENDIF
+      IF( ln_traadv_cen  ) THEN   ;   ioptio = ioptio + 1   ;   nadv = np_CEN      ;   ENDIF
+      IF( ln_traadv_fct  ) THEN   ;   ioptio = ioptio + 1   ;   nadv = np_FCT      ;   ENDIF
+      IF( ln_traadv_mus  ) THEN   ;   ioptio = ioptio + 1   ;   nadv = np_MUS      ;   ENDIF
+      IF( ln_traadv_ubs  ) THEN   ;   ioptio = ioptio + 1   ;   nadv = np_UBS      ;   ENDIF
+      IF( ln_traadv_qck  ) THEN   ;   ioptio = ioptio + 1   ;   nadv = np_QCK      ;   ENDIF
+      !
+      IF( ioptio /= 1 )   CALL ctl_stop( 'tra_adv_init: Choose ONE advection option in namelist namtra_adv' )
       !
       IF( ln_traadv_cen .AND. ( nn_cen_h /= 2 .AND. nn_cen_h /= 4 )   &          ! Centered
@@ -254,14 +241,4 @@
         CALL ctl_stop( 'tra_adv_init: FCT scheme, choose 2nd or 4th order' )
       ENDIF
-      IF( ln_traadv_fct .AND. nn_fct_zts > 0 ) THEN
-         IF( nn_fct_h == 4 ) THEN
-            nn_fct_h = 2
-            CALL ctl_stop( 'tra_adv_init: force 2nd order FCT scheme, 4th order does not exist with sub-timestepping' )
-         ENDIF
-         IF( .NOT.ln_linssh ) THEN
-            CALL ctl_stop( 'tra_adv_init: vertical sub-timestepping not allow in non-linear free surface' )
-         ENDIF
-         IF( nn_fct_zts == 1 )   CALL ctl_warn( 'tra_adv_init: FCT with ONE sub-timestep = FCT without sub-timestep' )
-      ENDIF
       IF( ln_traadv_ubs .AND. ( nn_ubs_v /= 2 .AND. nn_ubs_v /= 4 )   ) THEN     ! UBS
         CALL ctl_stop( 'tra_adv_init: UBS scheme, choose 2nd or 4th order' )
@@ -275,14 +252,6 @@
       ENDIF
       !
-      !                                !==  used advection scheme  ==!  
-      !                                      ! set nadv
-      IF( ln_traadv_cen                      )   nadv = np_CEN
-      IF( ln_traadv_fct                      )   nadv = np_FCT
-      IF( ln_traadv_fct .AND. nn_fct_zts > 0 )   nadv = np_FCT_zts
-      IF( ln_traadv_mus                      )   nadv = np_MUS
-      IF( ln_traadv_ubs                      )   nadv = np_UBS
-      IF( ln_traadv_qck                      )   nadv = np_QCK
-      !
-      IF(lwp) THEN                           ! Print the choice
+      !                                !==  Print the choice  ==!  
+      IF(lwp) THEN
          WRITE(numout,*)
          SELECT CASE ( nadv )
@@ -292,5 +261,4 @@
          CASE( np_FCT     )   ;   WRITE(numout,*) '      ===>>   FCT      scheme is used. Horizontal order: ', nn_fct_h,   &
             &                                                                      ' Vertical   order: ', nn_fct_v
-         CASE( np_FCT_zts )   ;   WRITE(numout,*) '      ===>>   use 2nd order FCT with ', nn_fct_zts,'vertical sub-timestepping'
          CASE( np_MUS     )   ;   WRITE(numout,*) '      ===>>   MUSCL    scheme is used'
          CASE( np_UBS     )   ;   WRITE(numout,*) '      ===>>   UBS      scheme is used'
